/***************************************************************************
 *   Copyright (C) 2009 by Kai Dombrowe <just89@gmx.de>                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef APPLET_HEADER
#define APPLET_HEADER


/// Qt
#include <QGraphicsLinearLayout>

/// own
#include "widget.h"



namespace Yasp
{


class YASP_EXPORT Applet : public Plasma::Applet
{
    Q_OBJECT


public:
    Applet(QObject *parent, const QVariantList &args);
    ~Applet();
    void init();


private:
    Yasp::Widget *_widget;
    QGraphicsLinearLayout *_layout;


private slots:
    void checkGeometry();
    void createConfigurationInterface(KConfigDialog *p_parent);


protected slots:
    void setWidget(Yasp::Widget *widget);


};


}; /// namespace Yasp


#endif
