/***************************************************************************
 *   Copyright (C) 2009 by Kai Dombrowe <just89@gmx.de>                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef LAYOUT_HEADER
#define LAYOUT_HEADER


/// Qt
#include <QGraphicsGridLayout>

/// own
#include "label.h"
#include "index.h"
#include "yasp_export.h"


namespace Yasp
{


class Frame;
class YASP_EXPORT Layout : public QObject, public QGraphicsGridLayout
{
    Q_OBJECT


public:
    Layout(QGraphicsWidget *parent);
    ~Layout();


public slots:
    void addItem(Yasp::Label *label, const int& row, const int& col, const int& rows, const int& cols);
    QList<Yasp::Label*> labels();
    void setTitle(Frame *title);
    Yasp::Label* labelAt(Yasp::Index index);
    void removeTitle(Yasp::Frame* frame);


private:
    QList<Yasp::Label*> _labels;
    int currentColumnCount;


private slots:
    void checkLabel(Yasp::Label::State newState);
    void removeItem(Label* label);


};


}; /// namespace Yasp


#endif
